function OnInitialize(tntCtrlID)
{
	debugOut('OnInitialize("'+tntCtrlID+'")');
	tntCtrl = element(tntCtrlID);
	var ttInstallTag = element('TTInstallTag');
	if (ttInstallTag)
	{
		ttInstallTag.innerHTML = '';
	}	
	doTNTCommand('Downloader().ShowProgressBar(1)');
	var eventCount = doTNTCommand('EventManager().GetEventCount()');
	for (var eIdx=1; eIdx<eventCount; eIdx++)
	{
		var eventName = doTNTCommand('EventManager().GetEventName('+eIdx+')');
		if (eval("typeof("+eventName+")") == 'function')
		{
			doTNTCommand('EventManager().SetEventEnabled('+eIdx+',1)');
		}
	}
	doTNTCommand('Viewer().LoadScene("'+tntSource+'")');
	setTNTFocus();
}

function OnSceneLoad(fileName)
{
	debugOut('OnSceneLoad("'+fileName+'")');
	doTNTCommand('CurrentViewport().SetViewportBackgroundColor('+tntBackColor+')');
	makeCameraGUI();
	makeAnimationGUI();
	makeBitmapGUI();
	setTNTFocus();
}

var objPrevDiffuseColor = 0;
var mouseOver = '';
var mouseKeyPressed = 0;

function OnFileDownloadComplete(fileName)
{
	debugOut('OnFileDownloadComplete("'+fileName+'")');
}

function OnExternalResourceMerge(uniqueNodeName, nodeIndex, fileName)
{
	debugOut('OnExternalResourceMerge("'+uniqueNodeName+'",'+nodeIndex+',"'+fileName+'")');
}

function OnLODMerge(uniqueNodeName, nodeIndex, fileName)
{
	debugOut('OnLODMerge("'+uniqueNodeName+'",'+nodeIndex+',"'+fileName+'")');
}

function OnNodeDistanceEventEnter(eventIndex)
{
	var distance = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventRadius()');
	var threshold = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventThreshold()');
	var nodeName0 = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventNode(0).GetName()');	
	var nodeName1 = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventNode(1).GetName()');	
	debugOut('OnNodeDistanceEventEnter() Distance = '+distance+' Threshold = '+threshold+' NodeName0 = "'+nodeName0+'" NodeName1 = "'+nodeName1+'"');
}

function OnNodeDistanceEventExit(eventIndex)
{
	var distance = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventRadius()');
	var threshold = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventThreshold()');
	var nodeName0 = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventNode(0).GetName()');	
	var nodeName1 = doTNTCommand('NodeDistEvent('+eventIndex+').GetNodeDistEventNode(1).GetName()');	
	debugOut('OnNodeDistanceEventExit() Distance = '+distance+' Threshold = '+threshold+' NodeName0 = "'+nodeName0+'" NodeName1 = "'+nodeName1+'"');
}

function OnMouseKeyPress(keyIndex)
{
	mouseKeyPressed = 1;
	if (mouseOver!='')
	{
		var objClick = mouseOver;
		if (doTNTCommand('GetSceneCount("Animation","'+objClick+'")')==0)
		{
			doTNTCommand('CreateAnimation("'+objClick+'").SetLoopStartFrame(0).SetLoopStopFrame('+tntFrameCount+').SetFrameRate(30).SetLoopCount(0).Play().Node("*").SetAnimation("'+objClick+'")');
		}
		else
		{
			doTNTCommand('Animation("'+objClick+'").PlayAnimation(Animation("Global").GetLoopStopFrame(),Animation("'+objClick+'").GetLoopStartFrame(),,0,)');
		}
	}	
	debugOut('OnMouseKeyPress('+keyIndex+')');
}

function OnMouseKeyRelease(keyIndex)
{
	mouseKeyPressed = 0;
	debugOut('OnMouseKeyRelease('+keyIndex+')');
}

function OnKeyPress(keyIndex)
{
	debugOut('OnKeyPress('+keyIndex+')');
}

function OnKeyRelease(keyIndex)
{
	debugOut('OnKeyRelease('+keyIndex+')');
}

function OnMouseEnter(nodeName, nodeIndex)
{
	debugOut('OnMouseEnter("'+nodeName+'",'+nodeIndex+')');
	objPrevDiffuseColor = doTNTCommand('Mesh("'+nodeName+'").GetMaterialDiffuseColor()');
	doTNTCommand('Mesh("'+nodeName+'").SetMaterialDiffuseColor(#FF0000)');
	if (mouseKeyPressed==0)
	{
		mouseOver = nodeName;
	}
}

function OnMouseExit(nodeName, nodeIndex)
{
	debugOut('OnMouseExit("'+nodeName+'",'+nodeIndex+')');
	if (objPrevDiffuseColor)
	{
		doTNTCommand('Mesh("'+nodeName+'").SetMaterialDiffuseColor('+objPrevDiffuseColor+')');
	}
	mouseOver = '';
}

function OnScriptError(debugText)
{
	debugOut('OnScriptError("'+debugText+'")');
}

function OnError(fileName,status)
{
	debugOut('OnError("'+fileName+'",'+status+')');
}

function saveImage()
{
	var thisDate = new Date();
	var year = thisDate.getFullYear();
	var month = thisDate.getMonth();
	var day = thisDate.getDate();
	var hours = thisDate.getHours();
	var minutes = thisDate.getMinutes();
	var seconds = thisDate.getSeconds();
	var milliseconds = thisDate.getMilliseconds();
	var sessionID = year+""+(month+1)+""+day+""+hours+""+minutes+""+seconds+""+milliseconds;	
	var iImageSizeFactor = parseInt(element("ImageSize").selectedIndex);
	var iImageFormatIndex = parseInt(element("ImageFormat").selectedIndex);
	var imageFormat = element("ImageFormat").options[iImageFormatIndex].value;
	doTNTCommand('Renderer().SaveImage("TurnTool_'+sessionID+''+imageFormat+'",'+iImageSizeFactor+',0.1)');
}

function makeCameraGUI()
{
	var cameraCount = doTNTCommand('GetCameraCount()');
	var html = '';
	for (var j=0; j<cameraCount; j++)
	{
		var cameraName = doTNTCommand('Camera('+j+').GetName()');
		html += '<input type="button" value="'+cameraName+'" class="camera" onclick="changeCamera(\''+cameraName+'\')">';
	}
	element('CameraCell').innerHTML = html;
}

function changeCamera(cameraName)
{
	var command = 'CurrentCamera().Match("'+cameraName+'",2000)';
	if (doTNTCommand('GetSceneCount("Node",Camera("'+cameraName+'").CameraTarget().GetName())')!=0)
	{
		command += '.CurrentCamera().CameraTarget().Match(Camera("'+cameraName+'").CameraTarget().GetName(),2000)';
	}
	doTNTCommand(command);
}

function makeAnimationGUI()
{
	var html = '';
	if(tntFrameCount > 1)
	{	
		html = '<input type="button" id="PlayButton" value="Play Forward" class="button" onclick="playAnimation()">';
	}
	html += '<input type="button" value="Restart" class="button" onclick="restart();" />';
	element('AnimationCell').innerHTML = html;
}

function playAnimation()
{
	if (doTNTCommand('GetSceneCount("Animation","Global")')==0)
	{
		doTNTCommand('CreateAnimation("Global").SetLoopStartFrame(0).SetLoopStopFrame('+tntFrameCount+').SetFrameRate(30).SetLoopCount(0).Play().Node("*").SetAnimation("Global")');
	}
	else
	{
		doTNTCommand('Animation("Global").PlayAnimation(Animation("Global").GetLoopStopFrame(),Animation("Global").GetLoopStartFrame(),,0,)');
	}
	element('PlayButton').value = (doTNTCommand('Animation("Global").GetLoopStartFrame()')==0)?"Play Backward":"Play Forward";
}

function restart()
{
	doTNTCommand('Camera(0).SetCurrentCamera().Node("*").SetAnimation(Animation("*").SetFrame(0).Stop().GetIndex())');
	element('PlayButton').value = "Play Forward";
}

function makeBitmapGUI()
{
	var iBitmapCount = doTNTCommand('GetBitmapCount()');
	if(iBitmapCount > 0)
	{
		var html = 'Select a texture <select id="BitmapSelection">';
		for( var bIdx=0; bIdx<iBitmapCount; bIdx++ )
		{
			var bitmapName = doTNTCommand('Bitmap('+bIdx+').GetBitmapFilename()');
			html += '<option value="'+bitmapName+'">'+bitmapName+'</option>';
		}
		html += '</select> path to image <input id="texturePath" type="text" size="15" value="drusty.png" /><input type="button" value="Load Texture" class="button" onclick="loadTexture();" />';
		element('TextureCell').innerHTML = html;
	}
}

function loadTexture()
{
	var texturePath = element('texturePath').value;
	var iBitmapIndex = parseInt(element("BitmapSelection").selectedIndex);
	var pBitmapName = element("BitmapSelection").options[iBitmapIndex].value;
	doTNTCommand('Bitmap("'+pBitmapName+'").LoadBitmap("'+texturePath+'")');
}

var objectListIndex = 0; //Index of first object curently shown.
var objectListMaxItem = 17; // Number of objects in list. 

function makeObjectList()
{
	element('LevelTable').innerHTML = 'Please wait!';
	var objectCount = doTNTCommand('GetMeshCount()');
	var objectEnd = objectListIndex+objectListMaxItem;
	if (objectEnd>objectCount) {
		objectEnd=objectCount;
	}
	var rs = '<div id="objectListHolder"><div id="objectListHeader">Check to hide object</div>';
	rs += '<div id="objectList">';
	rs += makeObjectListItems(objectListIndex,objectListMaxItem);
	rs += '</div><div id="objectListLess" class="objectListMoreLessHidden" onclick="objectListMoreLess(-1)">Prev page</div><div id="objectListMore" class="objectListMoreLessHidden" onclick="objectListMoreLess(1)">Next page</div>';
	rs += '</div>';
	element('LevelTable').innerHTML = rs;
	objectListMoreLessUpdate(objectEnd,objectCount);
}

function hideShowObject(id,boxValue)
{
	var objName = doTNTCommand('Mesh('+ id + ').GetName()');
	var bVisible = element('showHideChkBox' + id).checked;
	doTNTCommand('Mesh("'+objName+'").SetVisible('+((bVisible)?0:1)+')');
}

function makeObjectListItems(startIndex2,num)
{
	var objectCount = doTNTCommand('GetMeshCount()');
	var maxPage = objectListIndex+num;
	var rs = '\n';
	for(var m = objectListIndex; m < maxPage && m < objectCount; m++)
	{
		var objName = doTNTCommand('Mesh(' + m + ').GetName()');
		if(m%2 == 0)
			var objClass = ' class="objListEven"';
		else
			var objClass = ' class="objListOdd"';
		rs += '<div '+objClass+' onclick="hideShowObject('+m+');" ><input type="checkbox" id="showHideChkBox' + m + '" />'+m+' '+objName+'</div>';
	}
	return rs;
}

function objectListMoreLessUpdate(num, objectCount)
{
	if (objectListIndex+objectListMaxItem < objectCount)
		element('objectListMore').className = 'objectListMore';
	else
		element('objectListMore').className = 'objectListMoreLessHidden';
	if(objectListIndex >= objectListMaxItem)
		element('objectListLess').className = 'objectListLess';
	else
		element('objectListLess').className = 'objectListMoreLessHidden';
}

function objectListMoreLess(orgNum)
{
	var num = orgNum*objectListMaxItem;
	var objectCount = doTNTCommand('GetMeshCount()');
	var objectEnd = objectListIndex+objectListMaxItem;
	if (objectEnd>objectCount) 
		objectEnd=objectCount;
	if(objectListIndex < 0)
		objectListIndex = 0;
	objectListIndex = objectListIndex+num;
	var m = makeObjectListItems(objectListIndex+num,Math.abs(num));
	if(m != '') {
		element('objectList').innerHTML = m;
		objectListMoreLessUpdate(objectEnd,objectCount);
	}
}
